<script setup lang="ts">
  import { Product } from '@shopware-pwa/types';
  import { BoxLayout, DisplayMode } from '@shopware-pwa/composables-next';
  import { TransitionRoot } from '@headlessui/vue';
  import { getProductName, getSmallestThumbnailUrl } from '@shopware-pwa/helpers-next';
  import { formatProductOptions } from '~/helpers/formatProductOptions';

  const emits = defineEmits<{
    (e: 'click'): void;
  }>();

  const props = withDefaults(
    defineProps<{
      data?: Product;
      displayMode?: DisplayMode;
      boxLayout?: BoxLayout;
      loading?: boolean;
      watchers?: number;
      showRegulationPrice?: boolean;
      showPercentSaved?: boolean;
      isMainProduct?: boolean;
    }>(),
    {
      data: undefined,
      loading: false,
      displayMode: 'cover',
      boxLayout: 'standard',
      watchers: 0,
      showRegulationPrice: true,
      showPercentSaved: true,
      isMainProduct: false,
    },
  );

  const product = computed(() => props?.data);
  const imageLoaded = ref();

  const navigateToProductDetail = () => {
    emits('click');
  };

  const handleLoad = () => {
    imageLoaded.value = true;
  };
  const handleError = () => {
    imageLoaded.value = false;
  };

  const imageThumbnail = computed(() => {
    return (
      getSmallestThumbnailUrl(product.value?.cover?.media) || product.value?.cover?.media?.url || ''
    );
  });

  const additionalInfor = computed(() => {
    return formatProductOptions(
      product.value?.options?.map((option) => ({
        group: option.group?.name,
        name: option.translated?.name,
      })),
    );
  });
</script>
<template>
  <div v-if="loading || !product">
    <slot name="loading">
      <div class="max-w-60 flex animate-pulse flex-col gap-4 rounded-md">
        <div
          :class="{
            'w-full rounded-md bg-gray-100': true,
            'aspect-product-big-thumbnail': boxLayout === 'image',
            'aspect-product-standard-thumbnail': ['standard', 'minimal'].includes(boxLayout),
          }"
        />
        <div class="h-10 w-full rounded-sm bg-gray-100" />
        <div class="h-4 w-full rounded-sm bg-gray-100" />
        <div class="flex h-8 justify-between">
          <div class="w-3/5 rounded-sm bg-gray-100" />
          <div class="w-1/4 rounded-sm bg-gray-100" />
        </div>
        <div class="h-8 w-full rounded-md bg-gray-100" />
      </div>
    </slot>
  </div>
  <div v-else class="flex flex-col justify-between gap-4">
    <slot name="product-image">
      <div
        :class="{
          'border-border relative cursor-pointer overflow-hidden rounded-md border': true,
          'aspect-product-big-thumbnail': boxLayout === 'image',
          'aspect-product-standard-thumbnail': ['standard', 'minimal'].includes(boxLayout),
        }"
      >
        <div
          v-show="!imageThumbnail || !imageLoaded"
          class="h-full w-full animate-pulse bg-gray-100"
          @click="navigateToProductDetail"
        />
        <img
          v-show="imageThumbnail && imageLoaded"
          ref="imageElement"
          :src="imageThumbnail"
          :alt="getProductName({ product }) ?? ''"
          :class="{
            'h-full w-full': true,
            'object-cover': true,
          }"
          :style="{
            'object-fit': displayMode as any,
          }"
          @load="handleLoad"
          @error="handleError"
          @click="navigateToProductDetail"
        />
        <div
          v-if="isMainProduct"
          v-tooltip="{ content: $t('productHasVariantsTooltip') }"
          class="bg-darkgray-900/70 text-(white xs) absolute bottom-2 left-2 flex items-center gap-0.5 rounded-full p-1.5"
        >
          <span class="i-sw-solid:variants text-xs" />
        </div>
        <TransitionRoot
          :show="+watchers > 0"
          as="div"
          class="bg-darkgray-900/70 text-(white xs) absolute bottom-2 right-2 flex items-center gap-0.5 rounded-full px-2 py-1.5"
          enter="transition-all duration-200 ease-in-out"
          enter-from="opacity-0"
          enter-to="opacity-1"
          leave="transition-all duration-200 ease-in-out"
          leave-from="opacity-1"
          leave-to="opacity-0"
        >
          <span class="i-sw-solid:users text-xs" />
          <span>{{ watchers }}</span>
        </TransitionRoot>

        <slot name="product-badge">
          <ProductBadge class="absolute top-4" :product="product" layout="listing" />
        </slot>
      </div>
    </slot>
    <div name="product-meta">
      <div>
        <slot name="product-name">
          <h3
            class="text-(sm information-dark) min-h-11 leading-5.5 line-clamp-2 grow cursor-pointer text-ellipsis font-semibold"
            @click="navigateToProductDetail"
          >
            {{ getProductName({ product }) }}
          </h3>
        </slot>
        <slot name="product-properties">
          <p
            :class="[
              'text-(xs information-subdued) pt-1 font-medium',
              {
                'text-transparent': !additionalInfor,
              },
            ]"
          >
            {{ additionalInfor ? additionalInfor : $t('additionalInformation') }}
          </p>
        </slot>
      </div>
      <div class="flex h-12 flex-nowrap items-center justify-between gap-2 pt-3">
        <slot name="product-interact" />
        <slot name="product-price">
          <ProductPrice
            :product="product"
            :show-percent-saved="showPercentSaved"
            :show-regulation-price="showRegulationPrice"
            layout="listing"
          />
        </slot>
      </div>
    </div>
    <slot name="product-action" />
  </div>
</template>
